public class MemoriaVirtuale {

  public int nFrames;
  public Page[] Frames;
  public boolean full;
  public int victimAt;
  public int indexVic;
  public int tempo;

/*
 *metodo costruttore
 */  
    public MemoriaVirtuale(int totFrame) {
  	nFrames = totFrame;
  	Frames = new Page[nFrames];
  	full = false;
  	victimAt = -1;
  	indexVic = -1;
  	tempo = 0;
  	for(int i=0; i<nFrames; i++)
  		{ 
  			Frames[i] = new Page(-1);
  		}
  }

/*
 *metodo che verifica se i frames sono tutti occupati
 */
	public boolean MVpiena() {
		if (full)
			return true;
		else return false;	
	  	  }
  /*
   *metodo che aggiunge una pagina inserendola in un frame libero
   */	  
	  public void aggiungiP(Page pagina) {
	  	for (int i=0; i<nFrames; i++)
	  		{
	  		if (Frames[i].indice==(-1)){
	  				if (i==(nFrames-1))
	  				full=true;
	  			Frames[i].equals(pagina);
	  			break;
	  			}
	  			} 
	  	  }

 /*
  *metodo che sostituisce la pagina vittima con la nuova passata come argomento
  **/ 
	  public void sostituisci(Page pagina)
	  	{ 
	  		Frames[victimAt].equals(pagina);
	  		}
  
 /*
  *metodo di ricerca della vittima LRU
  */ 	
  public int vittimaLRU() {
  	
  	victimAt = 0;
  	for (int i=0; i<(nFrames-1); i++)
  		{
  			if (Frames[i+1].LRUcount<Frames[i].LRUcount)
  				{
  					victimAt = i+1;
  				}
  		}
  		indexVic = Frames[victimAt].indice;
  		return indexVic; 	
  }
/*
 *metodo di ricerca della vittima FIFO
 */
  public int vittimaFIFO() {
  	 	victimAt = 0;
  	  	for (int i=0; i<(nFrames-1); i++)
  		{
  			if (Frames[i+1].FIFOcount<Frames[i].FIFOcount)
  				{
  					victimAt = i+1;
  				}
  		}	
  		indexVic = Frames[victimAt].indice;
  		return indexVic;
  }

/*
 *metodo di ricerca della vittima LIFO
 */
  public int vittimaLIFO() {
  	 	victimAt = 0;
  	  	for (int i=0; i<(nFrames-1); i++)
  		{
  			if (Frames[i+1].FIFOcount>Frames[i].FIFOcount)
  				{
  					victimAt = i+1;
  				}
  		}	
  		indexVic = Frames[victimAt].indice;
  		return indexVic;
  }
/*
 *metodo di ricerca della vittima Ottimale
 */    
	public int vittimaOPT(int[] stringa)
	{
  	int vref = -1;
  	boolean trovato;
   	int indagato;
  	int iframe;
  	boolean vicFound=false;
  	victimAt = 0;
  
  	
  
  	for (iframe=0; iframe<nFrames; iframe++)
  	{	
  			if (!vicFound)
  		{
  		indagato = Frames[iframe].indice;
  		trovato = false;
  		
  		for (int p=stringa.length-1; p>tempo; p--)
  		{
  				if (!trovato)
  				{
  					if (stringa[p]==indagato)
  					{	
  					trovato=true;
  						if(p > vref)
  						{
  						vref=p;
  						victimAt=iframe;
  						}	
  					}
  					if ((p==tempo+1)&&(!trovato))
  					{
  					victimAt=iframe;
  					vicFound=true;	
  					}	
  				}
  				  			
  			}
  		}
  	}
  	indexVic = Frames[victimAt].indice; 
	return indexVic;
	}
  	
/*
 *metodo di ricerca della vittima LFU
 */
  public int vittimaLFU() {
  	int i;
  	victimAt = 0;
  	
  	for (i=0; i<(nFrames-1); i++)
  		{
  			if (Frames[i].REFcount<=Frames[i+1].REFcount)
  				{
  					victimAt = i;
  				}
  				else 
  					victimAt = i+1;
  				}
  		indexVic = Frames[victimAt].indice;
  		return indexVic;
  }

/*
 *metodo di ricerca della vittima MFU
 */
  public int vittimaMFU() {
  	int i;
  	victimAt = 0;
  	
  	for (i=0; i<(nFrames-1); i++)
  		{
  			if ((Frames[i].REFcount) >= (Frames[i+1].REFcount))
  				{
  					victimAt = i;
  				}
  				else 
  					victimAt = i+1;
  			}
  		indexVic = Frames[victimAt].indice;
  		return indexVic;
  		}
 /*
  *metodo per aggiornare i contatori di una pagina caricata
  */ 		
  public void aggiornaCont(int index)
  	{	int i;
  		for (i=0; i<(nFrames); i++)
  		{
  			if (Frames[i].indice==index)
  				{
  					Frames[i].Aggiorna(tempo);
  				}
  			}
  		}
  
  /*
   *metodo toString
   */		
  public String toString()
  	{	
  		String ans = ""; 
  		for (int i = 0; i < Frames.length; i++)
  			ans=ans + "   " + Frames[i].toString();
  		return ans;	
  	}
  	
  public int[] getMV()
  { 
  	
  	int[] indexList = new int[nFrames]; 
  	for (int c = 0; c<Frames.length; c++) 
  	{	
  		indexList[c] = Frames[c].indice;  		
  	
  	}
  	return indexList;
  }
  							 
}