public class Page {

  public int indice;
  public boolean inMV = false;
  public int LRUcount;
  public int REFcount;
  public int FIFOcount;

/*
 *costruttore di default
 */
	  public Page() {
	  indice = -1;
	  inMV = false;
	  LRUcount = 0;
	  REFcount = 0;
	  FIFOcount = 0;	
	  }	
 
 /*
  *costruttore con argomento
  */   
	  public Page(int index) {
	  indice = index;
	  inMV = false;
	  LRUcount = 0;
	  REFcount = 0;
	  FIFOcount = 0;
	  }
 
 /*
  *metodo che aggiorna la pagina caricata  
  */ 
	public void Aggiorna(int tempo)
	{
		REFcount++;
		LRUcount=tempo;
		if(FIFOcount==0)
			FIFOcount=tempo;
	}
	
/*
 *metodo che aggiorna la pagina rimossa
 */
	 public void nonInMV()
	{
		LRUcount = 0;
		REFcount = 0;
		FIFOcount = 0;
	}

/*
 *metodo equals che rende la pagina uguale a quella ricevuta come arg
 */
	public void equals(Page pagina)
	{
		indice = pagina.indice;
		inMV = pagina.inMV;
		LRUcount = pagina.LRUcount;
		FIFOcount = pagina.FIFOcount;
		REFcount = pagina.REFcount;
		}

/*
 *metodo toString
 */		
	public String toString()
	{
		return indice + "," + inMV + "," + LRUcount + "," + REFcount + 
			"," + FIFOcount + "   "; 
		}
}