/**
 * @(#)DialogMV.java
 * @author Claudia Rizzello
 * Classe della finestra di dialogo destinata a ricevere i dati.
 *
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;

public class DialogMV extends JDialog {
	 
 private JPanel pan;
 private JPanel pan1;
 private JPanel panrs;
 private JPanel pannf;
 private JPanel pan2;
 private JPanel panAl;
 private JScrollPane pandes;
 private JTextArea descriz;
 private JPanel pan3;
 private JLabel titolo;
 private JLabel rslab;
 private JLabel sugrs;
 private JLabel nflab;
 private JLabel sugnf;
 private JTextField rs;
 private JTextField nf; 
 private ButtonGroup gruppo;
 private JRadioButton lru;
 private JRadioButton fifo;
 private JRadioButton lifo;
 private JRadioButton opt;
 private JRadioButton lfu;
 private JRadioButton mfu;
 private JButton Esci;
 private JButton Ris;
 private JButton Step;
 private JButton Info;
 private String RefStr = "";
 private String numFrame = "";
 private int input[];
 private int algoritmo = 0;
 private int nFrame;
 public int SorR = 0;
 	
 /**
 * Costruttore
 */
 	public DialogMV() {
        		
		super();
		setSize(new Dimension(450, 400));
		Container cnt = getContentPane();
		pan = new JPanel();
		pan.setLayout(new FlowLayout(FlowLayout.CENTER,6,6));
		pan.setSize(new Dimension(450, 400));
		
		titolo = new JLabel();
		titolo.setText("INSERIRE I DATI RICHIESTI");
		pan.add(titolo);
		
		pan1 = new JPanel();
		pan1.setLayout( new GridLayout(3,1));
		pan1.setSize(450,60); 
		
		panrs = new JPanel();
		rslab = new JLabel();
		rslab.setText("Reference String:");
		panrs.add(rslab);
		
		rs = new JTextField(29);
		rs.setText("digitare qui gli indici di pagina separati da uno spazio");
		rs.setEditable(true);
		panrs.add(rs);
				
		pan1.add(panrs);
		
		pannf = new JPanel();
		pannf.setLayout(new FlowLayout(FlowLayout.LEFT, 6,4));
		nflab = new JLabel();
		nflab.setText("Numero di Frame:");
		pannf.add(nflab);
		
		nf = new JTextField(3);
		nf.setEditable(true);
		pannf.add(nf);
		
		pan1.add(pannf);
		
		sugnf = new JLabel();
		sugnf.setText("(Inserire il numero di frame disponibili)");
		pan1.add(sugnf);
		
		pan.add(pan1);
	    			
		pan2 = new JPanel();
		pan2.setSize(new Dimension(450,70));
		pan2.setLayout(new GridLayout(1,2,5,5));
		pan2.setBorder(new TitledBorder("ALGORITMO"));
		
		panAl = new JPanel();
		panAl.setSize(new Dimension(250,60));
		panAl.setLayout(new GridLayout(3,2,5,5));
		
		gruppo = new ButtonGroup();
		//bottoni radio
		lru = new JRadioButton("LRU");
		lru.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                lruActionPerformed(evt);
            }
        });
		gruppo.add(lru);
		fifo = new JRadioButton("FIFO");
		fifo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                fifoActionPerformed(evt);
            }
        });
		gruppo.add(fifo);
		lifo = new JRadioButton("LIFO");
		lifo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                lifoActionPerformed(evt);
            }
        });
		gruppo.add(lifo);
		opt = new JRadioButton("OPT");
		opt.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                optActionPerformed(evt);
            }
        });
		gruppo.add(opt);
		lfu = new JRadioButton("LFU");
		lfu.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                lfuActionPerformed(evt);
            }
        });
		gruppo.add(lfu);
		mfu = new JRadioButton("MFU");
		mfu.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                mfuActionPerformed(evt);
            }
        });
		gruppo.add(mfu);
		
		panAl.add(lru);	
		panAl.add(fifo);	
		panAl.add(lifo);	
		panAl.add(opt);	
		panAl.add(lfu);	
		panAl.add(mfu);
					
		pan2.add(panAl);
		
	
		descriz = new JTextArea("Selezionare uno degli algoritmi.", 6, 18);
		descriz.setEditable(false);
	   	pandes = new JScrollPane(descriz);
		pan2.add(pandes);
		pan.add(pan2);	
		
		pan3 = new JPanel();
		pan3.setSize(450, 50);
		pan3.setLayout(new FlowLayout(FlowLayout.RIGHT, 6,6));	
		//bottoni
		Esci = new JButton();
		Esci.setText("Esci");
		Esci.setToolTipText("Uscita dal programma");
        Esci.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                EsciActionPerformed(evt);
            }
        });
            
        Ris = new JButton();
        Ris.setToolTipText("Risultato immediato");
		Ris.setText("Risultato");
		Ris.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent evt) {
            RisActionPerformed(evt);
      }
    });
		
		Step = new JButton();
		Step.setText("Step by step");
		Step.setToolTipText("Procedura passo per passo");
		Step.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                StepActionPerformed(evt);
            }
        });
        
        Info = new JButton();
		Info.setText("?");
		Info.setToolTipText("help");
		Info.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                InfoActionPerformed(evt);
            }
        });
        pan3.add(Info, "RIGHT");
        pan3.add(Step);
        pan3.add(Ris);
        pan3.add(Esci);
                
        pan.add(pan3);
        
        cnt.add(pan);
 	} 

/**
 * Metodi Action Performed
 */		
	 private void EsciActionPerformed(ActionEvent evt) {
System.exit(0);
    }
    
    private void lruActionPerformed(ActionEvent evt) {
descriz.setText("LEAST RECENTLY USED: \n rimuove la pagina usata \n meno di recente.");
algoritmo = 1;
    }
    
     private void fifoActionPerformed(ActionEvent evt) {
descriz.setText("FIRST IN FIRST OUT: \n rimuove la prima pagina \n inserita.");
algoritmo = 2;
    }
    
     private void lifoActionPerformed(ActionEvent evt) {
descriz.setText("LAST IN FIRST OUT: \n rimuove l'ultima pagina \n inserita.");
algoritmo = 3;
    }
     private void optActionPerformed(ActionEvent evt) {
descriz.setText("OPTIMAL: \n rimuove la pagina che non verr \n utilizzata prossimamente.");
algoritmo = 4;
    }
     private void mfuActionPerformed(ActionEvent evt) {
descriz.setText("MOST FREQUENTLY USED: \n rimuove la pagina che  \n stata pi utilizzata.");
algoritmo = 5;
    }
    
     private void lfuActionPerformed(ActionEvent evt) {
descriz.setText("LEAST FREQUENTLY USED:\n rimuove la pagina che  \n stata meno utilizzata.");
algoritmo = 6;
    }
    
    private void InfoActionPerformed(ActionEvent evt)
    {	
    	 JOptionPane.showMessageDialog(null, "Programma che simula la sostituzione delle pagine. \n \n" +
    	 	"Chiede l'inserimento di: \n " +
    	   	"- Reference String : valori interi separati da uno spazio. \n" +
    	   	"- Numero di frames : un valore intero. \n \n" +
    	   	"Selezionare l'algoritmo (a destra appare la sua descrizione). \n" +
    	 	"Cliccare il pulsante STEP BY STEP per visualizzare la procedura passo per passo \n" +
    	 	"oppure cliccare il pulsante RISULTATO per vedere immediatamente tutti i passaggi. \n" , 
            "HELP", JOptionPane.INFORMATION_MESSAGE);
   }
    
    private void StepActionPerformed(ActionEvent evt) {
    
    	Thread t = new Thread(){
 	public void run(){
    
    Step.setEnabled(false);
    	
   	int allow = 1;
   	
   	try {
   	numFrame = nf.getText();
   	RefStr = rs.getText();
	}
	
	catch (NullPointerException e) {
		descriz.setText("compilare tutti i campi!");
		allow = 0;
	}
	String[] s = RefStr.split("\\s");
	input = new int[(s.length)];
		try {
		Integer.parseInt(numFrame);
		nFrame = Integer.parseInt(numFrame);
	}
		catch (NumberFormatException e) {
						descriz.setText("errore nei dati: \n reinserire il numero di frame.");
						allow = 0;
						}
	
		for (int c=0; c<s.length; c++)
   				  { 
   				  	  	try { 
   				  	  		Integer.parseInt(s[c]);
   				  	  		input[c] = Integer.parseInt(s[c]);
                	   	}
                	   		catch (NumberFormatException e) {
						descriz.setText("errore nei dati: \n reinserire la reference string.");
						allow = 0;
                	   		}
   				  }
   				if (algoritmo==0)
   				{
   						descriz.setText("errore nei dati: \n selezionare un algoritmo!");
   						allow = 0;
   				}  
                	   	if (allow==1)
                	   	{
                	   		SorR = 1;
                	   	}
                	   	Step.setEnabled(true);
	}

	};
  		t.start();
    }		
   
    
    private void RisActionPerformed(ActionEvent evt) throws NullPointerException, NumberFormatException {
   
	Thread t = new Thread(){
 	public void run(){
    Ris.setEnabled(false);
   	int allow = 1;
   	
   	try {
   	numFrame = nf.getText();
   	RefStr = rs.getText();
	}
	
	catch (NullPointerException e) {
		descriz.setText("compilare tutti i campi!");
		allow = 0;
	}
	String[] s = RefStr.split("\\s");
	input = new int[(s.length)];
		try {
		Integer.parseInt(numFrame);
		nFrame = Integer.parseInt(numFrame);
	}
		catch (NumberFormatException e) {
						descriz.setText("errore nei dati: \n reinserire il numero di frame.");
						allow = 0;
						}
	
		for (int c=0; c<s.length; c++)
   				  { 
   				  	  	try { 
   				  	  		Integer.parseInt(s[c]);
   				  	  		input[c] = Integer.parseInt(s[c]);
                	   	}
                	   		catch (NumberFormatException e) {
						descriz.setText("errore nei dati: \n reinserire la reference string.");
						allow = 0;
                	   		}
   				  }
   				if (algoritmo==0)
   				{
   						descriz.setText("errore nei dati: \n selezionare un algoritmo!");
   						allow = 0;
   				}  
                	   	if (allow==1)
                	   	{
                	   		SorR = 2;
                	   	}
                	   	Ris.setEnabled(true);
	}

	};
		t.start();
    }
	
                							
/**
 * Restituisce l'array contenente gli indici di pagina
 */			
	public int[] getRefString(){
		return input;
	}
	
/**
 * Restituisce il numero delle pagine
 */
	public int getNPage() {
		return input.length;
		}
/**
 * Restituisce il numero dei frame
 */	
	public int getNFrame(){
		return nFrame;
		}
/**
 * Restituisce l'algoritmo scelto
 */		
	public int getAlgor() {
		return algoritmo;
		}	
		
		}  