/**
 * @(#)MvSimul.java
 * @author Claudia Rizzello
 * MvSimul application:  il file di avvio del programma.
 *
 * @version 1.00 2008/1/15
 */
 
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class MvSimul {
	
	public static void main(String[] args) {
	int n;
	int[] RefString;
	int nFrame;
	int algor;
	int nPage;
	RisFrame Rf;
	StepFrame Sf;
	String algoritmo = "";
	int ancora = 0;
	
	//creo la finestra di dialogo
	DialogMV d = new DialogMV();
	d.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
	d.setBounds(200,100, 500,400);
	
	do {
	d.SorR = 0;
	ancora = 0;
	d.show();
	while (d.SorR==0)
	{}
		//prendo i dati dalla nestra di dialogo	
		nPage = d.getNPage();
		RefString = new int[nPage];
		RefString = d.getRefString();
		nFrame = d.getNFrame();
		algor = d.getAlgor();
		
		switch (algor)
		{
			case 1: algoritmo = "LRU"; break;
			case 2: algoritmo = "FIFO"; break;
			case 3: algoritmo = "LIFO"; break;
			case 4: algoritmo = "OPT"; break;
			case 5: algoritmo = "MFU"; break;
			case 6: algoritmo = "LFU"; break; 
		}
				
	if (d.SorR==2) {  //se l'utente ha scelto la procedura Step by Step
		
		d.hide();
		Rf = new RisFrame(RefString, nFrame, algor, algoritmo);
		Rf.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		Rf.setBounds(200,100, 500, 400);
		Rf.show();
		while (!Rf.Ricomincia())
		{}
		ancora = 1;
		Rf.dispose();
		}
	else				//se l'utente vuole il risultato immediato
	{	d.hide();
		Sf = new StepFrame(RefString, nFrame, algor, algoritmo);
		Sf.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		Sf.setBounds(200,100, 500, 400);
		Sf.show();
		while (!Sf.Ricomincia())
		{}
		ancora = 1;
		Sf.dispose();
	}	   
	} while (ancora == 1);  //permette di ricominciare, se l'utente lo desidera
}
}